#include "imp2c.h"

char productcode[31 + 1] = "CLC",
     fname[31 + 1] = "CLC",
     version[31 + 1] = "2",
     release[31 + 1] = "11",
     revision[31 + 1] = "3";

const char username[3 + 1] = "dp";

int
main (int argc, char **argv)
{
#define true 1
#define false 0
  static int nomrc = false;
  static int return_ = false;
  char lastdirectory[255 + 1];
  char thisdirectory[255 + 1];
  char file[127 + 1];
  int status;
  int count;
  int files;
  int total;
  char junk[255 + 1];
  char es[255 + 1];
  char rs[255 + 1];

  void checkfile ()
  {
    char line[255 + 1];
    char uline[255 + 1];
    int first;
    {
      if (!openinput (1, rs))
	{
	  fprintf (outfile, "--------------------------------------------------------------------------\n");
	  fprintf (outfile, "Warning: Unable to open log file %s\n", rs);

	}
      selectinput (1);
    }
    if (strstr (rs, ("]PLC.LOG")) || strstr (rs, ("plc.log"))
	|| (strstr (rs, ("mrc_")) && nomrc == true))
      {
	files -= 1;
	closeinput ();
	return;
      }

    fprintf (outfile, "--------------------------------------------------------------------------\n");
    fprintf (outfile, "Checking file %s\n", rs);

    first = true;
    {
      for (;;)
	{
	  if (!readline (line, sizeof(line))) {
	    closeinput ();
	    return;
	  }

	  strcpy(uline, line);
	  imp_toupper (uline);
	  if (strstr (uline, ("OUTPUT:")) || strstr (uline, ("PROCESSING:"))
	      || strstr (uline, ("INSTANCES:")))
	    {
	      fprintf (outfile, "%s\n", line);
	    }
	  else if (strstr (uline, ("ERROR")) || strstr (uline, ("WARNING"))
		   || strstr (uline, ("-W-NOMSG"))
		   || strstr (uline, ("INPUT FILE IS NOT OPEN"))
		   || strstr (uline, ("NOT FOUND"))
		   || strstr (uline, ("WITH WINDING DIFFERENCES"))
		   || strstr (uline, ("CANNOT COMPUTE LIMITS"))
		   || strstr (uline, ("NO DATA ON SELECTED LAYERS")))
	    {
	      if (strstr (line, (" the system definition of TED")))
		continue;
	      if (strstr (line, ("Lower case characters found on line")))
		continue;
	      if (strstr (line, ("No errors found in library file")))
		continue;
	      if (strstr (line, (" flashes in it.  The jobdeck said")))
		continue;
	      if (strstr (line, (" boundary has reversing points at")))
		continue;
	      if (strstr (line, (" boundary has no area at")))
		continue;
	      if (strstr (line, ("has no patterns on the disk")))
		continue;
	      if (strstr (line, ("The input resolution differs")))
		{
		  first = false;
		  continue;
		}
	      fprintf (outfile, "%c%s%s%c%s\n", esc, "[1m", line, esc, "[0m");
	      while (nextsymbol() == ' ' || nextsymbol() == tab)
		{
		  if (!readline (line, sizeof(line))) {
	            closeinput ();
	            return;
	          }
		  if (strstr (line, ("job terminated at")))
		    break;
                  fprintf (outfile, "%c%s%s%c%s\n", esc, "[1m", line, esc, "[0m");
		}
	      count += 1;
	    }
	}
    }
  }
  void updatefile ()
  {
    if (!openoutput (2, ".clc2"))
      {
	fatalerror ("Unable to open log file %s", rs);
      }
    selectoutput (2);
    fprintf (outfile, "\nLog file checked with CLC by %s on %s at %s\n",
		  username, imp_date(), imp_time());
    closeoutput ();
    selectoutput (1);
    spawncommand ("mv %s .clc1; cat .clc1 .clc2 > %s; rm .clc?", rs, rs);
  }

  // START OF MAIN PROGRAM

  imp_init(argc, argv);

  if (qualifierpresent ("IDENTIFY"))
    {
      printidentification ();
      if (!(qualifierpresent ("FILE")))
	exit(1);
    }
  if (qualifierpresent ("NOMRC"))
    nomrc = true;
  if (qualifierpresent ("RETURN"))
    return_ = true;
  strcpy(rs, qualifiers ("FILE"));
  if (*rs == '\0')
    {
      spawncommand ("clc *.log");
      exit (0);
    }
  for (;;)
    {
      files += 1;
      if (!((strcmp (rs, "*.log") == 0)))
	{
	  checkfile ();
	  updatefile ();
	}
      strcpy(rs, qualifiers ("FILE"));
      if (*rs == '\0') {
        files -= 1; // make correction
	break;
      }
    }
  fprintf (outfile, "--------------------------------------------------------------------------\n");
  if (!(files == 1 && count == 0))
    {
      fprintf (outfile, "Total of %0d file", files);
      if (files != 1)
	fputc ('s', outfile);
      fprintf (outfile, " checked");
      if (count > 0)
	{
	  fprintf (outfile, ", with %0d warning", count);
	  if (count != 1)
	    fputc ('s', outfile);
	}
      fprintf (outfile, "\n");
    }
  if (return_ == true)
    {
      selectinput (0);
      prompt ("Press RETURN to continue: ");
      (void)fgetc (infile);
    }
  exit(0);
  return(0);
}
